# 2장 메이븐 입문하기

## 리스트 2-1
```
package com.tuyano;

public class App 
{
    public static void main( String[] args )
    {
        System.out.println( "Hello World!" );
    }
}
```

## 리스트 2-2
```
package com.tuyano;

public class App {

    public static void main(String[] args){
        new App().printMessage("Taro");
    }

    public String getMessage(String name){
        return "Hi," + name + ". Welcome to Maven World!";
    }

    public void printMessage(String name){
        System.out.println("\n***** App class *****\n");
        System.out.println(this.getMessage(name));
        System.out.println("\n***** App class *****\n");
    }

}
```

## 리스트 2-3
```
<project xmlns="http://maven.apache.org/POM/4.0.0" 
    xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
    xsi:schemaLocation="http://maven.apache.org/POM/4.0.0
        http://maven.apache.org/xsd/maven-4.0.0.xsd">

    <modelVersion>4.0.0</modelVersion>

    <groupId>com.tuyano</groupId>
    <artifactId>mvn-app</artifactId>
    <version>1.0-SNAPSHOT</version>
    <packaging>jar</packaging>

    <name>mvn-app</name>
    <url>http://maven.apache.org</url>

    <properties>
        <project.build.sourceEncoding>UTF-8</project.build.sourceEncoding>
    </properties>

    <dependencies>
        <dependency>
            <groupId>junit</groupId>
            <artifactId>junit</artifactId>
            <version>3.8.1</version>
            <scope>test</scope>
        </dependency>
    </dependencies>
</project>
```

## 리스트 2-4
```
package com.tuyano;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;

public class AppTest extends TestCase
{

    public AppTest( String testName )
    {
        super( testName );
    }

    public static Test suite()
    {
        return new TestSuite( AppTest.class );
    }

    public void testApp()
    {
        assertTrue( true );
    }
}
```

## 리스트 2-5
```
package com.tuyano;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;

public class AppTest extends TestCase {
    private App app = null;

    public AppTest( String testName ){
        super( testName );
        app = new App();
    }

    public static Test suite(){
        return new TestSuite( AppTest.class );
    }

    public void testApp(){
        assertNotNull(app);
    }

    public void testGetMessage(){
        String name = "hoge";
        String msg = "Hi," + name + ". Welcome to Maven World!";
        assertEquals(app.getMessage("hoge"), msg);
    }
}
```

## 리스트 2-6
```
<build>
    <plugins>
        <plugin>
            <groupId>org.codehaus.mojo</groupId>
            <artifactId>exec-maven-plugin</artifactId>
            <version>1.5.0</version>
            <configuration>
                <mainClass>com.tuyano.App</mainClass>
            </configuration>
        </plugin>
    </plugins>
</build>
```

## 리스트 2-7
```
<build>
    <plugins>
        <plugin>
            <groupId>org.apache.maven.plugins</groupId>
            <artifactId>maven-jar-plugin</artifactId>
            <version>3.0.2</version>
            <configuration>
                <archive>
                    <manifest>
                        <addClasspath>true</addClasspath>
                        <mainClass>com.tuyano.App</mainClass>
                    </manifest>
                </archive>
            </configuration>
        </plugin>
    </plugins>
</build>
```

## 리스트 2-8
```
<dependency>
    <groupId>junit</groupId>
    <artifactId>junit</artifactId>
    <version>4.12</version>
</dependency>
```
